ARG GO_VERSION

FROM golang:{{ go.version }}-alpine

ENV GOCACHE=/go/.cache

ENV SSH_AUTH_SOCK=/ssh/socket/agent.sock

RUN set -eux \
  && apk upgrade --no-cache \
  && apk add --no-cache \
    bash \
    bash-completion \
    build-base \
    ca-certificates \
    coreutils \
    curl \
    findutils \
    grep \
    git \
    gcc \
    musl-dev \
    nano \
    openssh \
    shadow \
    socat \
    sudo \
    supervisor \
    tini \
    zip

COPY entrypoint.sh /ssh/entrypoint.sh
COPY supervisord.conf /etc/supervisord.conf

RUN set -eux \
  && ssh-keygen -A \
  && sed -i "s/#Port 22/Port {{ container_vars.ssh_port }}/g" /etc/ssh/sshd_config \
  && sed -i "s/#PasswordAuthentication yes/PasswordAuthentication no/g" /etc/ssh/sshd_config \
  && sed -i "s/#PermitUserEnvironment no/PermitUserEnvironment yes/g" /etc/ssh/sshd_config \
  && sed -i "s/#StrictModes yes/StrictModes no/g" /etc/ssh/sshd_config \
  && sed -i "s/AuthorizedKeysFile.*/AuthorizedKeysFile \/etc\/ssh\/authorized_keys/g" /etc/ssh/sshd_config

RUN set -eux \
  && sed -i "s/999/99/" /etc/group \
  && adduser -u 1000 -D user -s /bin/bash \
  && usermod -u {{ ansible_facts['user_uid'] }} user \
  && echo -e "password\npassword" | passwd user \
  && echo "/etc/profile.d/bash_completion.sh" | tee -a /home/user/.bash_profile \
  && echo "/etc/profile.d/locale.sh" | tee -a /home/user/.bash_profile \
  && chmod +x /etc/profile.d/*.sh

RUN set -eux \
  && mkdir -p /etc/sudoers.d \
  && echo "user ALL=(ALL) NOPASSWD: ALL" | tee /etc/sudoers.d/user \
  && chmod 0440 /etc/sudoers.d/user

{{ container_vars.dev.extra_instructions | default('') }}

RUN set -eux \
  && echo -e "[url \"ssh://git@gitlab.com\"]\ninsteadOf = https://gitlab.com" | tee -a /home/user/.gitconfig \
  && echo -e "[url \"ssh://git@github.com\"]\ninsteadOf = https://github.com" | tee -a /home/user/.gitconfig \
  && mkdir -p /home/user/.ssh/ \
  && sh -c "env" user | sed "/HOME=/d" | tee /home/user/.ssh/environment \
  && ssh-keyscan gitlab.com | tee -a /home/user/.ssh/known_hosts \
  && ssh-keyscan github.com | tee -a /home/user/.ssh/known_hosts \
  && chmod 0700 /home/user/.ssh/ \
  && chmod 0600 /home/user/.ssh/* \
  && chown -R user:user /home/user/

WORKDIR /home/user/project

ENTRYPOINT ["/sbin/tini", "--", "/ssh/entrypoint.sh"]

CMD ["/usr/bin/supervisord", "-n", "-c", "/etc/supervisord.conf"]
